//*******************************************************
// 	Zv iOtBbNkbcgpj Program ATMega328
// CPU Clock:1MHz
//   iq[Yf[^@WāAUWlgɂj
//
//  file name: ake6.c
//
//
//  2015/05/09  New  Programed by Taishi
//  2017/06/26  Modify ohb̃vOC by Taishi
//*******************************************************

#include	"pr_ake6_glcd.h"
#include	"timer.h"
#include	"ake6.h"
#include	"disp_ake6.h"

short			ake6_disp_pos[4];					// \ʒu PԖڂ̈ʒu[0]AQԖ[1]ARԖ[2]ASԖ[3]iO͎gȂ̈Ӗj
unsigned char	ake6_disp_index[4];					// \̃CfbNX PԖ[0]AQԖ[1]ARԖ[2]ASԖ[3]



static
const	unsigned char	sTime_ake6_kure6[25][6] ={	//@@@@@@@@@@閾@@@
//             閾   
//    mon day  hou min  hou min
	{  1,  1,    6, 11,  17,  7},					//[ 0] @P@P@UPPAPV@V
	{  1,  6,    6, 16,  17, 18},					//[ 1] @P@U@UPUAPVPW
	{  1, 21,    6, 14,  17, 31},					//[ 2] @PQP@UPSAPVRP
	{  2,  5,    6,  5,  17, 45},					//[ 3] @Q@T@U@TAPVST
	{  2, 20,    5, 50,  18,  0},					//[ 4] @QQO@TTOAPW@O
	{  3,  7,    5, 32,  18, 13},					//[ 5] @R@V@TRQAPWPR
	{  3, 22,    5, 11,  18, 26},					//[ 6] @RQQ@TPPAPWQU
	{  4,  6,    4, 49,  18, 39},					//[ 7] @S@U@SSXAPWRX
	{  4, 21,    4, 28,  18, 52},					//[ 8] @SQP@SQWAPWTQ
	{  5,  6,    4, 10,  19,  6},					//[ 9] @T@U@SPOAPX@U
	{  5, 21,    3, 56,  19, 20},					//[10] @TQP@RTUAPXQO
	{  6,  5,    3, 48,  19, 31},					//[11] @U@T@RSWAPXRP
	{  6, 20,    3, 47,  19, 38},					//[12] @UQO@RSVAPXRW
	{  7,  5,    3, 52,  19, 38},					//[13] @V@T@RTQAPXRW
	{  7, 25,    4,  7,  19, 28},					//[14] @VQT@S@VAPXQW
	{  8,  9,    4, 20,  19, 13},					//[15] @W@X@SQOAPXPR
	{  8, 24,    4, 33,  18, 54},					//[16] @WQS@SRRAPWTS
	{  9,  8,    4, 45,  18, 32},					//[17] @X@W@SSTAPWRQ
	{  9, 23,    4, 57,  18, 10},					//[18] @XQR@STVAPWPO
	{ 10,  8,    5,  0,  17, 48},					//[19] PO@W@T@OAPVSW
	{ 10, 23,    5, 21,  17, 29},					//[20] POQR@TQPAPVQX
	{ 11,  7,    5, 34,  17, 15},					//[21] PP@V@TRSAPVPT
	{ 11, 22,    5, 48,  17,  5},					//[22] PPQQ@TSWAPV@T
	{ 12,  6,    6,  1,  17,  3},					//[23] PQ@V@U@PAPV@R
	{ 12, 22,    6, 11,  17,  7},					//[24] PQQQ@UPPAPV@V
};

//***************************************
// oCi[@lɕϊ
//@
//@@FioCi[j
//@@FioCi[j
//***************************************
unsigned short	jihun_to_bin(unsigned char binh, unsigned char binm)
{
	unsigned short	r;

	r = (binh * 60) + binm;

	return(r);
}

//***************************************
// Á@̌̕vZ
//@
//@@FO=AP
//@@FJnioCi[j
//@@FJnioCi[j
//@@FIioCi[j
//@@FIioCi[j
//@̎͊JnI菬
//@̎͊JnI傫
//***************************************
unsigned short	keisan_hiru_yoru(unsigned char mode, unsigned char sh, unsigned char sm, unsigned char eh, unsigned char em)
{
	unsigned short	r=1;
	unsigned short	st;
	unsigned short	ed;

	st = jihun_to_bin(sh,sm);			// Jnlɕϊ
	ed = jihun_to_bin(eh,em);			// Ilɕϊ
	if(mode != 0){						// 
		ed += (24 * 60);
	}
	r = ed - st;						// 
	return(r);
}

//***************************************
// ZÁ@Z@̌oߕ
//@
//@@FO=ZAPZ
//@@FioCi[j
//@@FioCi[j
//@@FݎioCi[j
//@@FݕioCi[j
//@̎͊茻ݎ@傫
//@̎͊茻ݎ@傫i͂QS߂j
//***************************************
unsigned short	keisan_keika(unsigned char mode, unsigned char rh, unsigned char rm, unsigned char nh, unsigned char nm)
{
	unsigned short	r=1;
	unsigned short	rf;
	unsigned short	nw;

	rf = jihun_to_bin(rh,rm);			// lɕϊ
	nw = jihun_to_bin(nh,nm);			// ݂lɕϊ
	if(nw < rf){						// QS߂
		nw += (60 * 24);
	}
	r = nw - rf;						// 
	return(r);

}

//***************************************
//  ݎ@uZAZv̈ʒu߂
//@@ݎ͈ȉɗL
//		gRTC_min; ̃f[^ (0--59)
//		gRTC_hou; ̃f[^ (0--23j
//		gRTC_day; ̃f[^ (1--31)
//		gRTC_mon; ̃f[^ (1--12j
//@@iPAQSԕjStep_of_Round Œ`ihbgAXebvj
//@@̂Öʒu͖ZƂAZ̈ʒu #Step_of_Round ̔@Ƃ
//@@̕Á̕@ꂼUƂ
//
//    Z̃hbgiXebvj߂Bő Step_of_Round-1
//***************************************
unsigned short	get_ake6_step(void)
{
	unsigned short	r=0;
	unsigned char	i;
	unsigned short	hiru_yoru_hun;
	unsigned short	keika_hun;
	unsigned short	ake;
	unsigned short	kure;
	unsigned short	now;
	unsigned long	sekki;
	unsigned long	ima;

	// ݎrp̒lɂ
	ima   = gRTC_mon;
	ima <<= 8;
	ima  |= gRTC_day;
	ima <<= 8;
	ima  |= gRTC_hou;
	ima <<= 8;
	ima  |= gRTC_min;
	for(i=24;0 < i;i--){
		// ߋCrp̒lɂ
		sekki   = sTime_ake6_kure6[i][0];
		sekki <<= 8;
		sekki  |= sTime_ake6_kure6[i][1];
		sekki <<= 8;
		sekki  |= sTime_ake6_kure6[i][2];
		sekki <<= 8;
		sekki  |= sTime_ake6_kure6[i][3];

		if(sekki <= ima){		// ̐ߋC͈̔͂ɓ
			break;
		}
	}

	// ܂ߋC̖閾Ɠrp̒lɂ
	ake   = sTime_ake6_kure6[i][2];
	ake <<= 8;
	ake  |= sTime_ake6_kure6[i][3];

	kure   = sTime_ake6_kure6[i][4];
	kure <<= 8;
	kure  |= sTime_ake6_kure6[i][5];

	// ݎrp̒lɂ
	now  =  gRTC_hou;
	now <<= 8;
	now  |= gRTC_min;

	if((ake <= now) && (now <= kure)){																											// Ԃ̎
		hiru_yoru_hun = keisan_hiru_yoru(0, sTime_ake6_kure6[i][2], sTime_ake6_kure6[i][3], sTime_ake6_kure6[i][4], sTime_ake6_kure6[i][5]);	// ̕
		keika_hun = keisan_keika(0, sTime_ake6_kure6[i][2], sTime_ake6_kure6[i][3], gRTC_hou, gRTC_min);										// Z̌oߕ
		r = (unsigned short)(((unsigned long)(Step_of_Round / 2) * (unsigned long)keika_hun) / (unsigned long)hiru_yoru_hun);					// ʒuvZ@S̈ʒuS̕~oߕ
	}else{
		hiru_yoru_hun = keisan_hiru_yoru(1, sTime_ake6_kure6[i][4], sTime_ake6_kure6[i][5], sTime_ake6_kure6[i][2], sTime_ake6_kure6[i][3] );	// ̕
		keika_hun = keisan_keika(1, sTime_ake6_kure6[i][4], sTime_ake6_kure6[i][5], gRTC_hou, gRTC_min);										// Z̌oߕ
		r = (unsigned short)(((unsigned long)(Step_of_Round / 2) * (unsigned long)keika_hun) / (unsigned long)hiru_yoru_hun);					// ʒuvZ@S̈ʒuS̕~oߕ
		r += (Step_of_Round / 2);
	}

#ifdef	deb_disp
	disp_step_pos(hiru_yoru_hun,7);				//	@͖́@ifobOpj
	disp_step_pos(keika_hun,12);				//	o߁@ifobOpj
	disp_step_pos(i,17);						//	ԖځifobOpj
#endif

	return(r);
}

//***************************************
//  \p̈ʒu߂
//
//   Ȃ
//    kbĉwW߂iO`PQVj
//    ɕ\镶̃CfbNX߂iZOɂȂj
//    ߂lake6_disp_pos[0] PԖڂ̈ʒuAake6_disp_pos[1] QԖځAake6_disp_pos[2] RԖځAake6_disp_pos[3] SԖڂɂiO͎gȂ̈Ӗj
//    ake6_disp_index[0] PԖځAake6_disp_index[1] QԖځAake6_disp_index[2] RԖځAake6_disp_index[3] SԖڂɂ
//
//***************************************
void	get_ake6_pos(void)
{
	short	pos;
	short	left_pos;
	short	center_pos;
	short	right_pos;
	short	r_right_pos;
	short	ake_index;
	short	left_index;
	short	center_index;
	short	right_index;
	short	r_right_index;

	pos = (short)get_ake6_step();								// Z̃hbg߂

	center_pos = AKE6_CENTER_X  - (pos % Step_of_Ittoki);
	left_pos = center_pos - Step_of_Ittoki;
	right_pos = center_pos + Step_of_Ittoki;
	r_right_pos = right_pos + Step_of_Ittoki;

	ake6_disp_pos[0] = left_pos;
	ake6_disp_pos[1] = center_pos;
	ake6_disp_pos[2] = right_pos;
	ake6_disp_pos[3] = r_right_pos;

	ake_index = (pos / Step_of_Ittoki);							// iOZj

	left_index = ake_index - 1;
	center_index = ake_index;
	right_index = ake_index + 1;
	r_right_index = right_index + 1;

	if(left_index < 0){											// ZO̎
		ake6_disp_index[0] = (unsigned char)(left_index  + 12);
	}else{
		ake6_disp_index[0] = (unsigned char)(left_index);
	}

	if(center_index < 0){										// ZO̎
		ake6_disp_index[1] = (unsigned char)(center_index  + 12);
	}else{
		ake6_disp_index[1] = (unsigned char)(center_index);
	}

	if(right_index < 0){										// ZO̎
		ake6_disp_index[2] = (unsigned char)(right_index  + 12);
	}else if(12 <= right_index){
		ake6_disp_index[2] = (unsigned char)(right_index  - 12);
	}else{
		ake6_disp_index[2] = (unsigned char)(right_index);
	}

	if(r_right_index < 0){										// ZO̎
		ake6_disp_index[3] = (unsigned char)(r_right_index  + 12);
	}else if(12 <= r_right_index){
		ake6_disp_index[3] = (unsigned char)(r_right_index  - 12);
	}else{
		ake6_disp_index[3] = (unsigned char)(r_right_index);
	}
}
